/*
 * Copyright (c) 1991 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#ifndef __STDC__
#include <memory.h>
#endif
#include <dixie.h>
#include "ud.h"

struct entry Person;

parse_answer(s)
char *s;
{
	register int i;
	register char *cp, *ep, *ap, **vp, **tp;

	/* initialize */
	(void) memset((char *) &Person, 0, sizeof(Person));

	for (ep = dxi_firstentry(s); ep != NULL; ep = dxi_nextentry()) {
		cp = strrchr(dxi_getdn(ep), '=');
		cp++;
		strcpy(Person.name, cp);
		for (ap = dxi_firstattr(ep); ap != NULL; ap = dxi_nextattr(ap)){
			if (!strcasecmp(ap, TITLE)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.title[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, POSTAL_ADDRESS)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.baddr[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, PHONE_NUMBER)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.bphon[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, E_MAIL_ADDRESS)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.email[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, HOME_PHONE)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.hphon[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, HOME_ADDRESS)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.haddr[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, MLDESCRIPTION)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.mldsc[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, DESCRIPTION)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.descr[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, OBJECT_CLASS)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.class[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, OWNER)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.owner[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, MEMBERS)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.mmbrs[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, FAX)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.faxxx[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, UNIQNAME)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++)
					strcpy(Person.uid_x[i++], *tp);
				dxi_valuefree(vp);
			}
			else if (!strcasecmp(ap, COMMON_NAME)) {
				i = 0;
				vp = (char **) dxi_getvalues(ep, ap);
				for (tp = vp; *tp != NULL; tp++) {
					if (!strcmp(*tp, Person.name))
						continue;
					strcpy(Person.names[i++], *tp);
				}
				dxi_valuefree(vp);
			}
		}
	}
}

print_person()
{
	printf(" \"%s\"\n", Person.name);
	if (Person.names[0][0] != '\0')
		print_entry(Person.names, "Also known as:     ");
	if (Person.email[0][0] != '\0')
		print_entry(Person.email, "E-mail address:    ");
	if (Person.faxxx[0][0] != '\0')
		print_entry(Person.faxxx, "Fax number:        ");
	if (Person.bphon[0][0] != '\0')
		print_entry(Person.bphon, "Business phone:    ");
	if (Person.baddr[0][0] != '\0')
		print_entry(Person.baddr, "Business address:  ");
	if (Person.hphon[0][0] != '\0')
		print_entry(Person.hphon, "Home phone:        ");
	if (Person.haddr[0][0] != '\0')
		print_entry(Person.haddr, "Home address:      ");
	if (Person.title[0][0] != '\0')
		print_entry(Person.title, "Title:             ");
	if (Person.owner[0][0] != '\0')
		print_entry(Person.owner, "Owner:             ");
	if (Person.descr[0][0] != '\0')
		print_entry(Person.descr, "Short description: ");
	if (Person.mldsc[0][0] != '\0')
		print_entry(Person.mldsc, "Description:       ");
	if (Person.mmbrs[0][0] != '\0')
		print_entry(Person.mmbrs, "Members:           ");
	if (Person.uid_x[0][0] != '\0')
		print_entry(Person.uid_x, "Uniqname:          ");
}

print_entry(s, label)
char s[][MAX_VAL_SIZE], *label;
{
	char hex;
	register int i, j, k;
	register char c;
	int lead = strlen(label) + 2, isT61;

	printf("  %s", label);
	for (i = 0; s[i][0] != '\0'; i++) {
		isT61 = 0;
		if (i > 0) {
			if (!strncmp(label, "Home a", 6) || !strncmp(label, "Business a", 10)) {
				printf("  %s", label);
			}
			else {
				for (k = lead; k > 0; k--)
					putchar(' ');
			}
		}
		for (j = 0; s[i][j] != '\0'; j++) {
			c = s[i][j];
			switch (c) {
			case '{' :
				if (!strncasecmp(&s[i][j], T61, strlen(T61))) {
					isT61 = 1;
					j += strlen(T61) - 1;
				}
				else
					putchar(c);
				break;
			case '\\' :
				if (isT61) {
					c = s[i][++j];
					/* 
					 * slight hack here . . .
					 *
					 * If 'c' is a newline, eat it,
					 * and continue as usual.
					 */
					if (c == '\n')
						break;
					if (isdigit(c))
						hex = c - '0';
					else if (isupper(c))
						hex = c - 'A' + 10;
					else
						hex = c - 'a' + 10;
					hex <<= 4;
					c = s[i][++j];
					if (isdigit(c))
						hex += c - '0';
					else if (isupper(c))
						hex += c - 'A' + 10;
					else
						hex += c - 'a' + 10;
					putchar(hex);
				}
				else
					putchar(c);
				break;
			case '$' :
				putchar('\n');
				for (k = lead; k > 0; k--)
					putchar(' ');
				j++;
				break;
			case '\n' :
				putchar('%');
				putchar('\n');
				break;
			default:
				putchar(c);
			}
		}
		putchar('\n');
	}
	return;
}
